=== libs/bstrlib-05122010/CMakeLists.txt ===
PROJECT (bstrlib)

IF ("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "x86_64")
  SET (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -fPIC")
  SET (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fPIC")
  SET (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -fPIC")
  SET (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fPIC")
ENDIF ("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "x86_64")

SET (BSTRLIB_LIBRARY_SRC
#  bsafe.c
  bstraux.c
  bstrlib.c
  bstrwrap.cpp
  )
INCLUDE_DIRECTORIES (BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/include)
ADD_LIBRARY (bstrlib STATIC ${BSTRLIB_LIBRARY_SRC})
#INSTALL (TARGETS bstrlib DESTINATION lib)
