=== libs/nocedal/CMakeLists.txt ===
PROJECT (nocedal)

IF ("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "x86_64")
  SET (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -fPIC")
  SET (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fPIC")
  SET (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -fPIC")
  SET (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fPIC")
  SET (CMAKE_Fortran_FLAGS_RELEASE "${CMAKE_Fortran_FLAGS_RELEASE} -fPIC")
  SET (CMAKE_Fortran_FLAGS_DEBUG "${CMAKE_Fortran_FLAGS_DEBUG} -fPIC")
ENDIF ("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "x86_64")


# For plm_fortran.h
INCLUDE_DIRECTORIES (BEFORE ${CMAKE_BINARY_DIR})

# We only need this one
SET (NOCEDAL_LIBRARY_FORTRAN_SRC
  lbfgsb_2_1.f
  )
SET (NOCEDAL_LIBRARY_C_SRC
  lbfgsb_2_1.c
  )

IF (PLM_USE_F2C)
  ADD_LIBRARY (nocedal STATIC ${NOCEDAL_LIBRARY_C_SRC})
ELSE (PLM_USE_F2C)
  ADD_LIBRARY (nocedal STATIC ${NOCEDAL_LIBRARY_FORTRAN_SRC})
ENDIF (PLM_USE_F2C)

## JAS 2011.01.24
## I have disabled this INSTALL since it would be inappropriate
## for our CPack packages to install libnocedal.a
##
IF (PLM_OLD_INSTALL_TARGETS)
  INSTALL (TARGETS nocedal DESTINATION lib)
ENDIF (PLM_OLD_INSTALL_TARGETS)
