=== debian/changelog ===
plastimatch (1.5.5+dfsg0-2) unstable; urgency=low

  * Make the test suit fatal on supported arches

 -- Dominique Belhachemi <domibel@debian.org>  Wed, 09 Nov 2011 23:10:50 -0500

plastimatch (1.5.5+dfsg0-1) unstable; urgency=low

  * new upstream release

 -- Gregory C. Sharp <gregsharp.geo@yahoo.com>  Mon, 31 Oct 2011 22:54:37 -0400

plastimatch (1.5.4+dfsg0-1) unstable; urgency=low

  * upload to unstable (Closes: #629344)

  [Gregory C. Sharp]
  * new upstream release

  [Andreas Tille]
  * fixed Vcs fields

  [Dominique Belhachemi]
  * build depend on libinsighttoolkit3-dev (>= 3.20.0-15)
    due to the containing multi-arch fix

 -- Gregory C. Sharp <gregsharp.geo@yahoo.com>  Sun, 09 Oct 2011 20:41:35 -0400

plastimatch (1.5.3.dfsg0-1) experimental; urgency=low

  [Dominique Belhachemi]
  * removed src/plastimatch/opencl* files due to copyright issues
  * added dfsg0 to package version string

 -- Gregory C. Sharp <gregsharp.geo@yahoo.com>  Sun, 11 Sep 2011 16:58:58 -0400

plastimatch (1.5.3-1) experimental; urgency=low

  * Initial release (Closes: #629344)

 -- Gregory C. Sharp <gregsharp.geo@yahoo.com>  Sun, 24 Jul 2011 22:30:24 -0400
